/*******************************************************************************
* File Name: HAN_Bus_Slave_Clock_2.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_HAN_Bus_Slave_Clock_2_H)
#define CY_CLOCK_HAN_Bus_Slave_Clock_2_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void HAN_Bus_Slave_Clock_2_StartEx(uint32 alignClkDiv);
#define HAN_Bus_Slave_Clock_2_Start() \
    HAN_Bus_Slave_Clock_2_StartEx(HAN_Bus_Slave_Clock_2__PA_DIV_ID)

#else

void HAN_Bus_Slave_Clock_2_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void HAN_Bus_Slave_Clock_2_Stop(void);

void HAN_Bus_Slave_Clock_2_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 HAN_Bus_Slave_Clock_2_GetDividerRegister(void);
uint8  HAN_Bus_Slave_Clock_2_GetFractionalDividerRegister(void);

#define HAN_Bus_Slave_Clock_2_Enable()                         HAN_Bus_Slave_Clock_2_Start()
#define HAN_Bus_Slave_Clock_2_Disable()                        HAN_Bus_Slave_Clock_2_Stop()
#define HAN_Bus_Slave_Clock_2_SetDividerRegister(clkDivider, reset)  \
    HAN_Bus_Slave_Clock_2_SetFractionalDividerRegister((clkDivider), 0u)
#define HAN_Bus_Slave_Clock_2_SetDivider(clkDivider)           HAN_Bus_Slave_Clock_2_SetDividerRegister((clkDivider), 1u)
#define HAN_Bus_Slave_Clock_2_SetDividerValue(clkDivider)      HAN_Bus_Slave_Clock_2_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define HAN_Bus_Slave_Clock_2_DIV_ID     HAN_Bus_Slave_Clock_2__DIV_ID

#define HAN_Bus_Slave_Clock_2_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define HAN_Bus_Slave_Clock_2_CTRL_REG   (*(reg32 *)HAN_Bus_Slave_Clock_2__CTRL_REGISTER)
#define HAN_Bus_Slave_Clock_2_DIV_REG    (*(reg32 *)HAN_Bus_Slave_Clock_2__DIV_REGISTER)

#define HAN_Bus_Slave_Clock_2_CMD_DIV_SHIFT          (0u)
#define HAN_Bus_Slave_Clock_2_CMD_PA_DIV_SHIFT       (8u)
#define HAN_Bus_Slave_Clock_2_CMD_DISABLE_SHIFT      (30u)
#define HAN_Bus_Slave_Clock_2_CMD_ENABLE_SHIFT       (31u)

#define HAN_Bus_Slave_Clock_2_CMD_DISABLE_MASK       ((uint32)((uint32)1u << HAN_Bus_Slave_Clock_2_CMD_DISABLE_SHIFT))
#define HAN_Bus_Slave_Clock_2_CMD_ENABLE_MASK        ((uint32)((uint32)1u << HAN_Bus_Slave_Clock_2_CMD_ENABLE_SHIFT))

#define HAN_Bus_Slave_Clock_2_DIV_FRAC_MASK  (0x000000F8u)
#define HAN_Bus_Slave_Clock_2_DIV_FRAC_SHIFT (3u)
#define HAN_Bus_Slave_Clock_2_DIV_INT_MASK   (0xFFFFFF00u)
#define HAN_Bus_Slave_Clock_2_DIV_INT_SHIFT  (8u)

#else 

#define HAN_Bus_Slave_Clock_2_DIV_REG        (*(reg32 *)HAN_Bus_Slave_Clock_2__REGISTER)
#define HAN_Bus_Slave_Clock_2_ENABLE_REG     HAN_Bus_Slave_Clock_2_DIV_REG
#define HAN_Bus_Slave_Clock_2_DIV_FRAC_MASK  HAN_Bus_Slave_Clock_2__FRAC_MASK
#define HAN_Bus_Slave_Clock_2_DIV_FRAC_SHIFT (16u)
#define HAN_Bus_Slave_Clock_2_DIV_INT_MASK   HAN_Bus_Slave_Clock_2__DIVIDER_MASK
#define HAN_Bus_Slave_Clock_2_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_HAN_Bus_Slave_Clock_2_H) */

/* [] END OF FILE */
