/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "Han_Bus_Slave_Diff.h"
#include "Han_Bus_Slave_Diff_UART.h"
#include "Han_Bus_Slave_Diff_UART_Debug.h"
#include "Han_Bus_Slave_Diff_Timer.h"
#include "Han_Bus_Slave_Diff_TX_Int.h"
#include "Han_Bus_Slave_Diff_RX_Int.h"
#include "Han_Bus_Slave_Diff_Timeout_Int.h"
#include "Han_Bus_Slave_Diff_Control_Reg.h"
#include "Han_Bus_Slave_Diff_Comp_0.h"
#include "Han_Bus_Slave_Diff_Comp_1.h"

#define Han_Bus_Slave_Diff_OPEN_PORT_1()          {Han_Bus_Slave_Diff_control_byte |=      2; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}
#define Han_Bus_Slave_Diff_CLOSE_PORT_1()         {Han_Bus_Slave_Diff_control_byte &= 0xFF-2; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}

#define Han_Bus_Slave_Diff_RECONNECT_PORT_0()     {Han_Bus_Slave_Diff_control_byte |=      1; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}
#define Han_Bus_Slave_Diff_LOOPBACK_PORT_0()      {Han_Bus_Slave_Diff_control_byte &= 0xFF-1; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}

#define Han_Bus_Slave_Diff_LINK_LED_ON_PORT_0()   {Han_Bus_Slave_Diff_control_byte |=      4; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}
#define Han_Bus_Slave_Diff_LINK_LED_OFF_PORT_0()  {Han_Bus_Slave_Diff_control_byte &= 0xFF-4; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}

#define Han_Bus_Slave_Diff_RESET_1_TIMEOUT_TIMER()  {Han_Bus_Slave_Diff_control_byte |=      0x80; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}
#define Han_Bus_Slave_Diff_RESET_2_TIMEOUT_TIMER()  {Han_Bus_Slave_Diff_control_byte &= 0xFF-0x80; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}
                                                

#define Han_Bus_Slave_Diff_STOP_TIMEOUT_TIMER()   {}  //{Han_Bus_Slave_Diff_control_byte |=      0x80; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}
#define Han_Bus_Slave_Diff_START_TIMEOUT_TIMER()  {}  //{Han_Bus_Slave_Diff_control_byte &= 0xFF-0x80; Han_Bus_Slave_Diff_Control_Reg_Write(Han_Bus_Slave_Diff_control_byte);}

unsigned char  Han_Bus_Slave_Diff_message_buffer[256];
unsigned char* Han_Bus_Slave_Diff_message_buffer_head;
unsigned char* Han_Bus_Slave_Diff_message_buffer_tail;
unsigned int   Han_Bus_Slave_Diff_buffer_length = 0;
unsigned char  Han_Bus_Slave_Diff_control_byte  = 0;
unsigned char  Han_Bus_Slave_Diff_flags         = 0;

#define FLAGS_PORT_1_FOUND_SLAVE        1


#define STATE_WAITING_MESSAGE_START     0
#define STATE_QUERYING_PORT_1           1
#define STATE_PACKET_ONGOING            2
#define STATE_BLOCK_STARTED             3
#define STATE_MY_BLOCK_STARTED          4

unsigned char Han_Bus_Slave_Diff_state = STATE_WAITING_MESSAGE_START;

#define TOKEN_START_PACKET          0x18
#define TOKEN_START_BLOCK           0x22
#define TOKEN_PORT_QUERY            0xAA
#define TOKEN_PORT_QUERY_REPLY      0xBB
#define TOKEN_PORT_QUERY_TIMEOUT    0x11        // This is not a real token. It's just a value that's use to signal to the port
                                                // query state machine that a timeout happened

#define Han_Bus_Slave_Diff_SET_FLAG(f)    {Han_Bus_Slave_Diff_flags |=      f;}
#define Han_Bus_Slave_Diff_CLEAR_FLAG(f)  {Han_Bus_Slave_Diff_flags &= 0xff-f;}
#define Han_Bus_Slave_Diff_FLAG_IS_SET(f) (Han_Bus_Slave_Diff_flags&f)


void Han_Bus_Slave_Diff_Handle_State_Waiting_Message_Start(unsigned char c)
{
    switch (c)
    {
        case TOKEN_PORT_QUERY:
            Han_Bus_Slave_Diff_LINK_LED_ON_PORT_0();                      // There's someone talking to us from upstream! Turn on the Link0 LED
            Han_Bus_Slave_Diff_CLOSE_PORT_1();                            
            Han_Bus_Slave_Diff_RECONNECT_PORT_0();
            Han_Bus_Slave_Diff_UART_PutChar(TOKEN_PORT_QUERY_REPLY);
            CyDelayUs(3);                                               // Wait until token is sent back upstream
            
            Han_Bus_Slave_Diff_OPEN_PORT_1();                             // Now send a token to Port 1
            Han_Bus_Slave_Diff_LOOPBACK_PORT_0();                         // and make sure any reply comes back to us, not back upstream
            Han_Bus_Slave_Diff_UART_PutChar(TOKEN_PORT_QUERY);
            Han_Bus_Slave_Diff_RESET_1_TIMEOUT_TIMER();
            Han_Bus_Slave_Diff_state = STATE_QUERYING_PORT_1;
            Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(Han_Bus_Slave_Diff_state);
            Han_Bus_Slave_Diff_RESET_2_TIMEOUT_TIMER();
            break;
            
        case TOKEN_START_PACKET:
            Han_Bus_Slave_Diff_UART_PutChar(TOKEN_START_PACKET);
            Han_Bus_Slave_Diff_state = STATE_PACKET_ONGOING;
            Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(Han_Bus_Slave_Diff_state);
            break;
    }
}


void Han_Bus_Slave_Diff_Handle_State_Packet_Ongoing(unsigned char c)
{
    Han_Bus_Slave_Diff_UART_PutChar(TOKEN_START_BLOCK);
    switch (c)
    {
        case TOKEN_START_BLOCK:
            Han_Bus_Slave_Diff_state = STATE_BLOCK_STARTED;
            Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(Han_Bus_Slave_Diff_state);
            break;
    }
}

/*
void Han_Bus_Slave_Diff_Handle_State_Packet_Ongoing(unsigned char c)
{
    switch (c)
    {
        case TOKEN_START_BLOCK:
            Han_Bus_Slave_Diff_UART_PutChar(TOKEN_START_BLOCK);
            Han_Bus_Slave_Diff_state = STATE_BLOCK_STARTED;
            break;
    }
}
*/




void Han_Bus_Slave_Diff_Handle_State_Querying_Port_1(unsigned char c)
{
    switch (c)
    {
        case TOKEN_PORT_QUERY_REPLY:                                    // Success!   We got a reply on Port 1.
            Han_Bus_Slave_Diff_OPEN_PORT_1();                             
            break;
        
        case TOKEN_PORT_QUERY_TIMEOUT:                                  // Failure!   We got no reply on Port 1.
            Han_Bus_Slave_Diff_CLOSE_PORT_1();                             
            break;
            
        default:                                                        // Strange!   We got a wrong reply on port 1.
            return;
    }        

    Han_Bus_Slave_Diff_RECONNECT_PORT_0();
    Han_Bus_Slave_Diff_state = STATE_WAITING_MESSAGE_START;
    Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(Han_Bus_Slave_Diff_state);
}


void Han_Bus_Slave_Diff_Spoof_Byte_Received(unsigned char c)
{
    Han_Bus_Slave_Diff_Handle_State_Waiting_Message_Start(c);
}


// ---------------------------------------------------------
// Transmit Interrupt Handler  (I don't think this is needed
// ---------------------------------------------------------
CY_ISR(Han_Bus_Slave_Diff_TX_Int_Handler)
{
    Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(0x81);
}

// -------------------------------------------
// Receive Interrupt Handler
// -------------------------------------------
CY_ISR(Han_Bus_Slave_Diff_RX_Int_Handler)
{
    Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(0x82);
    unsigned char c = Han_Bus_Slave_Diff_UART_GetChar();
    Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(c);
    
    switch(Han_Bus_Slave_Diff_state)
    {
        case STATE_WAITING_MESSAGE_START:
            Han_Bus_Slave_Diff_Handle_State_Waiting_Message_Start(c);
            break;

        case STATE_QUERYING_PORT_1:
            Han_Bus_Slave_Diff_Handle_State_Querying_Port_1(c);
            break;
    }
}

// --------------------------
// Time out Interrupt Handler
// --------------------------
CY_ISR(Han_Bus_Slave_Diff_Timeout_Int_Handler)
{
    Han_Bus_Slave_Diff_Timer_ClearInterrupt(Han_Bus_Slave_Diff_Timer_INTR_MASK_TC);
    Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(0x83);
    
    
    switch(Han_Bus_Slave_Diff_state)
    {
        case STATE_WAITING_MESSAGE_START:
            Han_Bus_Slave_Diff_STOP_TIMEOUT_TIMER();
            // Do nothing
            break;
        
        case STATE_QUERYING_PORT_1:
            Han_Bus_Slave_Diff_STOP_TIMEOUT_TIMER();
            Han_Bus_Slave_Diff_Handle_State_Querying_Port_1(TOKEN_PORT_QUERY_TIMEOUT);
            break;
        }
}


void Test()
{
    unsigned char i = 0;
  
    /*
    while(1)
    {
        Han_Bus_Slave_Diff_UART_PutChar(i++);
        CyDelayUs(300);
    }
    */
    
    Han_Bus_Slave_Diff_OPEN_PORT_1();
    while(1)
    {
        Han_Bus_Slave_Diff_UART_PutString("Hello");
        CyDelay(5);
    }
}

void Test_Timeout(void)
{
    Han_Bus_Slave_Diff_OPEN_PORT_1();
    Han_Bus_Slave_Diff_UART_PutChar(0x99);
    Han_Bus_Slave_Diff_Timer_Start();
    
    while(1)
    {
    }
}



void Han_Bus_Slave_Diff_Start()
{
    Han_Bus_Slave_Diff_state = STATE_WAITING_MESSAGE_START;
    
    Han_Bus_Slave_Diff_message_buffer_head = Han_Bus_Slave_Diff_message_buffer;
    Han_Bus_Slave_Diff_message_buffer_tail = Han_Bus_Slave_Diff_message_buffer;
    Han_Bus_Slave_Diff_buffer_length       = 0;
    Han_Bus_Slave_Diff_RECONNECT_PORT_0();
    Han_Bus_Slave_Diff_CLOSE_PORT_1();
    Han_Bus_Slave_Diff_LINK_LED_OFF_PORT_0();
    Han_Bus_Slave_Diff_UART_Start();
    Han_Bus_Slave_Diff_Comp_0_Start();
    Han_Bus_Slave_Diff_Comp_1_Start();
    Han_Bus_Slave_Diff_TX_Int_StartEx(Han_Bus_Slave_Diff_TX_Int_Handler);                        
    Han_Bus_Slave_Diff_RX_Int_StartEx(Han_Bus_Slave_Diff_RX_Int_Handler);                        
    
    Han_Bus_Slave_Diff_Timeout_Int_StartEx(Han_Bus_Slave_Diff_Timeout_Int_Handler);                        // Now enable the interrupt, so we can use it again later.
    Han_Bus_Slave_Diff_Timer_Start();

    Han_Bus_Slave_Diff_UART_Debug_Start();
    Han_Bus_Slave_Diff_UART_Debug_SpiUartWriteTxData(Han_Bus_Slave_Diff_state);
    //Test_Timeout();
    //Test();
}






/* [] END OF FILE */
