/*******************************************************************************
* File Name: Han_Bus_Slave_Diff_Comp_0_PM.c
* Version 1.20
*
* Description:
*  This file provides the power management source code APIs for the
*  Comparator.
*
* Note:
*  None
*
********************************************************************************
* Copyright 2013-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#include "Han_Bus_Slave_Diff_Comp_0.h"

#if(!Han_Bus_Slave_Diff_Comp_0_CHECK_DEEPSLEEP_SUPPORT)
    static Han_Bus_Slave_Diff_Comp_0_BACKUP_STRUCT Han_Bus_Slave_Diff_Comp_0_backup =
    {
        0u, /* enableState */
    };
#endif /* (Han_Bus_Slave_Diff_Comp_0_CHECK_DEEPSLEEP_SUPPORT) */


/*******************************************************************************
* Function Name: Han_Bus_Slave_Diff_Comp_0_SaveConfig
********************************************************************************
*
* Summary:
*  Empty function. Included for consistency with other components.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Han_Bus_Slave_Diff_Comp_0_SaveConfig(void)
{

}


/*******************************************************************************
* Function Name: Han_Bus_Slave_Diff_Comp_0_RestoreConfig
********************************************************************************
*
* Summary:
*  Empty function. Included for consistency with other components.
*
* Parameters:
*  None
*
* Return:
*  None
*
********************************************************************************/
void Han_Bus_Slave_Diff_Comp_0_RestoreConfig(void)
{

}


/*******************************************************************************
* Function Name: Han_Bus_Slave_Diff_Comp_0_Sleep
********************************************************************************
*
* Summary:
*  This is the preferred API to prepare the component for sleep. The Sleep() API 
*  saves the current component state. Call the Comp_Sleep() function before 
*  calling the CySysPmDeepSleep() or the CySysPmHibernate() functions.
*  The "Deep sleep operation" option has an influence on this function
*  implementation.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Han_Bus_Slave_Diff_Comp_0_Sleep(void)
{
#if(!Han_Bus_Slave_Diff_Comp_0_CHECK_DEEPSLEEP_SUPPORT)
    if(Han_Bus_Slave_Diff_Comp_0_CHECK_PWR_MODE_OFF)
    {
        Han_Bus_Slave_Diff_Comp_0_backup.enableState = 1u;
        Han_Bus_Slave_Diff_Comp_0_Stop();
    }
    else /* Component is disabled */
    {
        Han_Bus_Slave_Diff_Comp_0_backup.enableState = 0u;
    }
#endif /* (Han_Bus_Slave_Diff_Comp_0_CHECK_DEEPSLEEP_SUPPORT) */
}


/*******************************************************************************
* Function Name: Han_Bus_Slave_Diff_Comp_0_Wakeup
********************************************************************************
*
* Summary:
*  This is the preferred API to restore the component to the state when Sleep() 
*  was called. The Wakeup() function will also re-enable the component. 
*  The "Deep sleep operation" option has an influence on this function
*  implementation.
*
* Parameters:
*  None
*
* Return:
*  None
*
*******************************************************************************/
void Han_Bus_Slave_Diff_Comp_0_Wakeup(void)
{
#if(!Han_Bus_Slave_Diff_Comp_0_CHECK_DEEPSLEEP_SUPPORT)
    if(0u != Han_Bus_Slave_Diff_Comp_0_backup.enableState)
    {
        /* Enable Comp's operation */
        Han_Bus_Slave_Diff_Comp_0_Enable();
    } /* Do nothing if Comp was disabled before */
#endif /* (Han_Bus_Slave_Diff_Comp_0_CHECK_DEEPSLEEP_SUPPORT) */
}


/* [] END OF FILE */

