/***************************************************************************//**
* \file Han_Bus_Slave_Diff_UART_Debug_PINS.h
* \version 3.20
*
* \brief
*  This file provides constants and parameter values for the pin components
*  buried into SCB Component.
*
* Note:
*
********************************************************************************
* \copyright
* Copyright 2013-2016, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_SCB_PINS_Han_Bus_Slave_Diff_UART_Debug_H)
#define CY_SCB_PINS_Han_Bus_Slave_Diff_UART_Debug_H

#include "cydevice_trm.h"
#include "cyfitter.h"
#include "cytypes.h"


/***************************************
*   Conditional Compilation Parameters
****************************************/

/* Unconfigured pins */
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_RX_WAKE_SCL_MOSI_PIN  (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_RX_SCL_MOSI_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_TX_SDA_MISO_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SCLK_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS0_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS1_PIN                 (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS2_PIN                 (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS3_PIN                 (1u)

/* Mode defined pins */
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_I2C_PINS                (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_PINS         (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SCLK_PIN     (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_MOSI_PIN     (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_MISO_PIN     (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS0_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS1_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS2_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS3_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_SLAVE_PINS          (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_SLAVE_MOSI_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_SLAVE_MISO_PIN      (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_TX_PIN             (0u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RX_TX_PIN          (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RX_PIN             (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RX_WAKE_PIN        (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RTS_PIN            (1u)
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_CTS_PIN            (1u)

/* Unconfigured pins */
#define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_RX_WAKE_SCL_MOSI_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_RX_SCL_MOSI_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_TX_SDA_MISO_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SCLK_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SS0_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS0_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SS1_PIN                (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS1_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SS2_PIN                (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS2_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SS3_PIN                (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS3_PIN)

/* Mode defined pins */
#define Han_Bus_Slave_Diff_UART_Debug_I2C_PINS               (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_I2C_PINS)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_PINS        (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_PINS)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SCLK_PIN    (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SCLK_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MOSI_PIN    (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_MOSI_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MISO_PIN    (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_MISO_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS0_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS0_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS1_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS1_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS2_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS2_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS3_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_MASTER_SS3_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_PINS         (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_SLAVE_PINS)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MOSI_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_SLAVE_MOSI_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MISO_PIN     (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_SPI_SLAVE_MISO_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_UART_TX_PIN            (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_TX_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_UART_RX_TX_PIN         (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RX_TX_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_UART_RX_PIN            (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RX_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_UART_RX_WAKE_PIN       (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RX_WAKE_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_UART_RTS_PIN           (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_RTS_PIN)
#define Han_Bus_Slave_Diff_UART_Debug_UART_CTS_PIN           (0u == Han_Bus_Slave_Diff_UART_Debug_REMOVE_UART_CTS_PIN)


/***************************************
*             Includes
****************************************/

#if (Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI) */

#if (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI) */

#if (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO) */

#if (Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_spi_sclk.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SCLK) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_spi_ss0.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS1_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_spi_ss1.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS1_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS2_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_spi_ss2.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS2_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS3_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_spi_ss3.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS3_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS)
    #include "Han_Bus_Slave_Diff_UART_Debug_scl.h"
    #include "Han_Bus_Slave_Diff_UART_Debug_sda.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_PINS)
#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SCLK_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_sclk_m.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SCLK_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MOSI_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_mosi_m.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MOSI_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MISO_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_miso_m.h"
#endif /*(Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MISO_PIN) */
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_PINS) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_PINS)
    #include "Han_Bus_Slave_Diff_UART_Debug_sclk_s.h"
    #include "Han_Bus_Slave_Diff_UART_Debug_ss_s.h"

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MOSI_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_mosi_s.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MOSI_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MISO_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_miso_s.h"
#endif /*(Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MISO_PIN) */
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_PINS) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS0_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_ss0_m.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS0_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS1_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_ss1_m.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS1_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS2_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_ss2_m.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS2_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS3_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_ss3_m.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS3_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_TX_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_tx.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_TX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RX_TX_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_rx_tx.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RX_TX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RX_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_rx.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RX_WAKE_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_rx_wake.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RX_WAKE_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RTS_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_rts.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RTS_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_CTS_PIN)
    #include "Han_Bus_Slave_Diff_UART_Debug_cts.h"
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_CTS_PIN) */


/***************************************
*              Registers
***************************************/

#if (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_SEL_I2C   (Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM_SPI)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi__0__HSIOM_UART)
    
#elif (Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_SEL_I2C   (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM_SPI)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__HSIOM_UART)    
   
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_INTCFG_REG (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__INTCFG)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_INTCFG_PTR ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__0__INTCFG)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_INTCFG_TYPE_POS  (Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi__SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_INTCFG_TYPE_MASK ((uint32) Han_Bus_Slave_Diff_UART_Debug_INTCFG_TYPE_MASK << \
                                                                           Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_INTCFG_TYPE_POS)
#else
    /* None of pins Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN or Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN present.*/
#endif /* (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_SEL_I2C   (Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM_SPI)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_SEL_I2C   (Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM_SPI)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_spi_sclk__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_SEL_I2C   (Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM_SPI)
#if !(Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V0 || Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V1)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_spi_ss0__0__HSIOM_UART)
#endif /* !(Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V0 || Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V1) */
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS1_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_REG  (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_PTR  ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_MASK     (Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_POS      (Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_SEL_GPIO (Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_SEL_I2C  (Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_HSIOM_SEL_SPI  (Han_Bus_Slave_Diff_UART_Debug_spi_ss1__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS1_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS2_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_REG     (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_PTR     ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_MASK     (Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_POS      (Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_SEL_GPIO (Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_SEL_I2C  (Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_HSIOM_SEL_SPI  (Han_Bus_Slave_Diff_UART_Debug_spi_ss2__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS2_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS3_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_REG     (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_PTR     ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_MASK     (Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_POS      (Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_SEL_GPIO (Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_SEL_I2C  (Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM_I2C)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_HSIOM_SEL_SPI  (Han_Bus_Slave_Diff_UART_Debug_spi_ss3__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS3_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS)
    #define Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_REG  (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_scl__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_PTR  ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_scl__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_MASK     (Han_Bus_Slave_Diff_UART_Debug_scl__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_POS      (Han_Bus_Slave_Diff_UART_Debug_scl__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_SEL_GPIO (Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_SEL_I2C  (Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM_I2C)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SDA_HSIOM_REG  (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SDA_HSIOM_PTR  ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SDA_HSIOM_MASK     (Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SDA_HSIOM_POS      (Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SDA_HSIOM_SEL_GPIO (Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SDA_HSIOM_SEL_I2C  (Han_Bus_Slave_Diff_UART_Debug_sda__0__HSIOM_I2C)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_PINS)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_S_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_sclk_s__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_S_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_sclk_s__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_S_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_sclk_s__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_S_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_sclk_s__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_S_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_sclk_s__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_S_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_sclk_s__0__HSIOM_SPI)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_S_HSIOM_REG    (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss0_s__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_S_HSIOM_PTR    ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss0_s__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_S_HSIOM_MASK       (Han_Bus_Slave_Diff_UART_Debug_ss0_s__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_S_HSIOM_POS        (Han_Bus_Slave_Diff_UART_Debug_ss0_s__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_S_HSIOM_SEL_GPIO   (Han_Bus_Slave_Diff_UART_Debug_ss0_s__0__HSIOM_GPIO)  
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_S_HSIOM_SEL_SPI    (Han_Bus_Slave_Diff_UART_Debug_ss0_s__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_PINS) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_S_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_mosi_s__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_S_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_mosi_s__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_S_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_mosi_s__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_S_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_mosi_s__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_S_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_mosi_s__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_S_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_mosi_s__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MOSI_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MISO_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_S_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_miso_s__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_S_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_miso_s__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_S_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_miso_s__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_S_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_miso_s__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_S_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_miso_s__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_S_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_miso_s__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_SLAVE_MISO_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MISO_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_M_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_miso_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_M_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_miso_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_M_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_miso_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_M_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_miso_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_M_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_miso_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_M_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_miso_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MISO_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_M_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_mosi_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_M_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_mosi_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_M_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_mosi_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_M_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_mosi_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_M_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_mosi_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_M_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_mosi_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_MOSI_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SCLK_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_M_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_sclk_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_M_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_sclk_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_M_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_sclk_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_M_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_sclk_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_M_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_sclk_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_M_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_sclk_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SCLK_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS0_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_M_HSIOM_REG    (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss0_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_M_HSIOM_PTR    ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss0_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_M_HSIOM_MASK       (Han_Bus_Slave_Diff_UART_Debug_ss0_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_M_HSIOM_POS        (Han_Bus_Slave_Diff_UART_Debug_ss0_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_M_HSIOM_SEL_GPIO   (Han_Bus_Slave_Diff_UART_Debug_ss0_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_M_HSIOM_SEL_SPI    (Han_Bus_Slave_Diff_UART_Debug_ss0_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS0_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS1_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_M_HSIOM_REG    (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss1_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_M_HSIOM_PTR    ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss1_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_M_HSIOM_MASK       (Han_Bus_Slave_Diff_UART_Debug_ss1_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_M_HSIOM_POS        (Han_Bus_Slave_Diff_UART_Debug_ss1_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_M_HSIOM_SEL_GPIO   (Han_Bus_Slave_Diff_UART_Debug_ss1_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS1_M_HSIOM_SEL_SPI    (Han_Bus_Slave_Diff_UART_Debug_ss1_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS1_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS2_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_M_HSIOM_REG    (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss2_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_M_HSIOM_PTR    ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss2_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_M_HSIOM_MASK       (Han_Bus_Slave_Diff_UART_Debug_ss2_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_M_HSIOM_POS        (Han_Bus_Slave_Diff_UART_Debug_ss2_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_M_HSIOM_SEL_GPIO   (Han_Bus_Slave_Diff_UART_Debug_ss2_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS2_M_HSIOM_SEL_SPI    (Han_Bus_Slave_Diff_UART_Debug_ss2_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS2_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS3_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_M_HSIOM_REG    (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss3_m__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_M_HSIOM_PTR    ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_ss3_m__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_M_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_ss3_m__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_M_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_ss3_m__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_M_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_ss3_m__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_SS3_M_HSIOM_SEL_SPI   (Han_Bus_Slave_Diff_UART_Debug_ss3_m__0__HSIOM_SPI)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SPI_MASTER_SS3_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RX_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_rx__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_rx__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_RX_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_rx__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_rx__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_rx__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_rx__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RX_WAKE_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_rx_wake__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_rx_wake__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_rx_wake__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_rx_wake__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_rx_wake__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_rx_wake__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_WAKE_RX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_CTS_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_CTS_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_cts__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_CTS_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_cts__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_CTS_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_cts__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_CTS_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_cts__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_CTS_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_cts__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_CTS_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_cts__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_CTS_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_TX_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_tx__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_tx__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_TX_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_tx__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_tx__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_tx__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_TX_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_tx__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_TX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RX_TX_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_TX_HSIOM_REG   (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_rx_tx__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_TX_HSIOM_PTR   ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_rx_tx__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_RX_TX_HSIOM_MASK      (Han_Bus_Slave_Diff_UART_Debug_rx_tx__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_TX_HSIOM_POS       (Han_Bus_Slave_Diff_UART_Debug_rx_tx__0__HSIOM_SHIFT)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_TX_HSIOM_SEL_GPIO  (Han_Bus_Slave_Diff_UART_Debug_rx_tx__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_RX_TX_HSIOM_SEL_UART  (Han_Bus_Slave_Diff_UART_Debug_rx_tx__0__HSIOM_UART)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RX_TX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_UART_RTS_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_RTS_HSIOM_REG      (*(reg32 *) Han_Bus_Slave_Diff_UART_Debug_rts__0__HSIOM)
    #define Han_Bus_Slave_Diff_UART_Debug_RTS_HSIOM_PTR      ( (reg32 *) Han_Bus_Slave_Diff_UART_Debug_rts__0__HSIOM)
    
    #define Han_Bus_Slave_Diff_UART_Debug_RTS_HSIOM_MASK     (Han_Bus_Slave_Diff_UART_Debug_rts__0__HSIOM_MASK)
    #define Han_Bus_Slave_Diff_UART_Debug_RTS_HSIOM_POS      (Han_Bus_Slave_Diff_UART_Debug_rts__0__HSIOM_SHIFT)    
    #define Han_Bus_Slave_Diff_UART_Debug_RTS_HSIOM_SEL_GPIO (Han_Bus_Slave_Diff_UART_Debug_rts__0__HSIOM_GPIO)
    #define Han_Bus_Slave_Diff_UART_Debug_RTS_HSIOM_SEL_UART (Han_Bus_Slave_Diff_UART_Debug_rts__0__HSIOM_UART)    
#endif /* (Han_Bus_Slave_Diff_UART_Debug_UART_RTS_PIN) */


/***************************************
*        Registers Constants
***************************************/

/* HSIOM switch values. */ 
#define Han_Bus_Slave_Diff_UART_Debug_HSIOM_DEF_SEL      (0x00u)
#define Han_Bus_Slave_Diff_UART_Debug_HSIOM_GPIO_SEL     (0x00u)
/* The HSIOM values provided below are valid only for Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V0 
* and Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V1. It is not recommended to use them for 
* Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V2. Use pin name specific HSIOM constants provided 
* above instead for any SCB IP block version.
*/
#define Han_Bus_Slave_Diff_UART_Debug_HSIOM_UART_SEL     (0x09u)
#define Han_Bus_Slave_Diff_UART_Debug_HSIOM_I2C_SEL      (0x0Eu)
#define Han_Bus_Slave_Diff_UART_Debug_HSIOM_SPI_SEL      (0x0Fu)

/* Pins settings index. */
#define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN_INDEX   (0u)
#define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN_INDEX       (0u)
#define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN_INDEX       (1u)
#define Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_INDEX       (2u)
#define Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_INDEX       (3u)
#define Han_Bus_Slave_Diff_UART_Debug_SS1_PIN_INDEX                  (4u)
#define Han_Bus_Slave_Diff_UART_Debug_SS2_PIN_INDEX                  (5u)
#define Han_Bus_Slave_Diff_UART_Debug_SS3_PIN_INDEX                  (6u)

/* Pins settings mask. */
#define Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN_MASK ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN_MASK     ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN_MASK     ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_MASK     ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_MASK     ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_SS1_PIN_MASK                ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_SS1_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_SS2_PIN_MASK                ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_SS2_PIN_INDEX)
#define Han_Bus_Slave_Diff_UART_Debug_SS3_PIN_MASK                ((uint32) 0x01u << Han_Bus_Slave_Diff_UART_Debug_SS3_PIN_INDEX)

/* Pin interrupt constants. */
#define Han_Bus_Slave_Diff_UART_Debug_INTCFG_TYPE_MASK           (0x03u)
#define Han_Bus_Slave_Diff_UART_Debug_INTCFG_TYPE_FALLING_EDGE   (0x02u)

/* Pin Drive Mode constants. */
#define Han_Bus_Slave_Diff_UART_Debug_PIN_DM_ALG_HIZ  (0u)
#define Han_Bus_Slave_Diff_UART_Debug_PIN_DM_DIG_HIZ  (1u)
#define Han_Bus_Slave_Diff_UART_Debug_PIN_DM_OD_LO    (4u)
#define Han_Bus_Slave_Diff_UART_Debug_PIN_DM_STRONG   (6u)


/***************************************
*          Macro Definitions
***************************************/

/* Return drive mode of the pin */
#define Han_Bus_Slave_Diff_UART_Debug_DM_MASK    (0x7u)
#define Han_Bus_Slave_Diff_UART_Debug_DM_SIZE    (3u)
#define Han_Bus_Slave_Diff_UART_Debug_GET_P4_PIN_DM(reg, pos) \
    ( ((reg) & (uint32) ((uint32) Han_Bus_Slave_Diff_UART_Debug_DM_MASK << (Han_Bus_Slave_Diff_UART_Debug_DM_SIZE * (pos)))) >> \
                                                              (Han_Bus_Slave_Diff_UART_Debug_DM_SIZE * (pos)) )

#if (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_CHECK_TX_SDA_MISO_PIN_USED \
                (Han_Bus_Slave_Diff_UART_Debug_PIN_DM_ALG_HIZ != \
                    Han_Bus_Slave_Diff_UART_Debug_GET_P4_PIN_DM(Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso_PC, \
                                                   Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso_SHIFT))
#endif /* (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_CHECK_SS0_PIN_USED \
                (Han_Bus_Slave_Diff_UART_Debug_PIN_DM_ALG_HIZ != \
                    Han_Bus_Slave_Diff_UART_Debug_GET_P4_PIN_DM(Han_Bus_Slave_Diff_UART_Debug_spi_ss0_PC, \
                                                   Han_Bus_Slave_Diff_UART_Debug_spi_ss0_SHIFT))
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN) */

/* Set bits-mask in register */
#define Han_Bus_Slave_Diff_UART_Debug_SET_REGISTER_BITS(reg, mask, pos, mode) \
                    do                                           \
                    {                                            \
                        (reg) = (((reg) & ((uint32) ~(uint32) (mask))) | ((uint32) ((uint32) (mode) << (pos)))); \
                    }while(0)

/* Set bit in the register */
#define Han_Bus_Slave_Diff_UART_Debug_SET_REGISTER_BIT(reg, mask, val) \
                    ((val) ? ((reg) |= (mask)) : ((reg) &= ((uint32) ~((uint32) (mask)))))

#define Han_Bus_Slave_Diff_UART_Debug_SET_HSIOM_SEL(reg, mask, pos, sel) Han_Bus_Slave_Diff_UART_Debug_SET_REGISTER_BITS(reg, mask, pos, sel)
#define Han_Bus_Slave_Diff_UART_Debug_SET_INCFG_TYPE(reg, mask, pos, intType) \
                                                        Han_Bus_Slave_Diff_UART_Debug_SET_REGISTER_BITS(reg, mask, pos, intType)
#define Han_Bus_Slave_Diff_UART_Debug_SET_INP_DIS(reg, mask, val) Han_Bus_Slave_Diff_UART_Debug_SET_REGISTER_BIT(reg, mask, val)

/* Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_DR(val) - Sets I2C SCL DR register.
*  Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_HSIOM_SEL(sel) - Sets I2C SCL HSIOM settings.
*/
/* SCB I2C: scl signal */
#if (Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V0)
#if (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS)
    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_DR(val) Han_Bus_Slave_Diff_UART_Debug_scl_Write(val)

    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_HSIOM_SEL(sel) \
                          Han_Bus_Slave_Diff_UART_Debug_SET_HSIOM_SEL(Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_REG,  \
                                                         Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_MASK, \
                                                         Han_Bus_Slave_Diff_UART_Debug_SCL_HSIOM_POS,  \
                                                         (sel))
    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SCL_SET_HIGH  (0u == Han_Bus_Slave_Diff_UART_Debug_scl_Read())

/* Unconfigured SCB: scl signal */
#elif (Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_DR(val) \
                            Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi_Write(val)

    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_HSIOM_SEL(sel) \
                    Han_Bus_Slave_Diff_UART_Debug_SET_HSIOM_SEL(Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG,  \
                                                   Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_MASK, \
                                                   Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_POS,  \
                                                   (sel))

    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SCL_SET_HIGH  (0u == Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi_Read())

#elif (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_DR(val) \
                            Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi_Write(val)


    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_HSIOM_SEL(sel) \
                            Han_Bus_Slave_Diff_UART_Debug_SET_HSIOM_SEL(Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_REG,  \
                                                           Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_MASK, \
                                                           Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_POS,  \
                                                           (sel))

    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SCL_SET_HIGH  (0u == Han_Bus_Slave_Diff_UART_Debug_uart_rx_i2c_scl_spi_mosi_Read())

#else
    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_DR(val)        do{ /* Does nothing */ }while(0)
    #define Han_Bus_Slave_Diff_UART_Debug_SET_I2C_SCL_HSIOM_SEL(sel) do{ /* Does nothing */ }while(0)

    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SCL_SET_HIGH  (0u)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS) */

/* SCB I2C: sda signal */
#if (Han_Bus_Slave_Diff_UART_Debug_I2C_PINS)
    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SDA_SET_HIGH  (0u == Han_Bus_Slave_Diff_UART_Debug_sda_Read())
/* Unconfigured SCB: sda signal */
#elif (Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SDA_SET_HIGH  (0u == Han_Bus_Slave_Diff_UART_Debug_uart_tx_i2c_sda_spi_miso_Read())
#else
    #define Han_Bus_Slave_Diff_UART_Debug_WAIT_SDA_SET_HIGH  (0u)
#endif /* (Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_PIN) */
#endif /* (Han_Bus_Slave_Diff_UART_Debug_CY_SCBIP_V0) */

/* Clear UART wakeup source */
#if (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_CLEAR_UART_RX_WAKE_INTR        do{ /* Does nothing */ }while(0)
    
#elif (Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_CLEAR_UART_RX_WAKE_INTR \
            do{                                      \
                (void) Han_Bus_Slave_Diff_UART_Debug_uart_rx_wake_i2c_scl_spi_mosi_ClearInterrupt(); \
            }while(0)

#elif(Han_Bus_Slave_Diff_UART_Debug_UART_RX_WAKE_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_CLEAR_UART_RX_WAKE_INTR \
            do{                                      \
                (void) Han_Bus_Slave_Diff_UART_Debug_rx_wake_ClearInterrupt(); \
            }while(0)
#else
#endif /* (Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN) */


/***************************************
* The following code is DEPRECATED and
* must not be used.
***************************************/

/* Unconfigured pins */
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_MOSI_SCL_RX_WAKE_PIN    Han_Bus_Slave_Diff_UART_Debug_REMOVE_RX_WAKE_SCL_MOSI_PIN
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_MOSI_SCL_RX_PIN         Han_Bus_Slave_Diff_UART_Debug_REMOVE_RX_SCL_MOSI_PIN
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_MISO_SDA_TX_PIN         Han_Bus_Slave_Diff_UART_Debug_REMOVE_TX_SDA_MISO_PIN
#ifndef Han_Bus_Slave_Diff_UART_Debug_REMOVE_SCLK_PIN
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SCLK_PIN                Han_Bus_Slave_Diff_UART_Debug_REMOVE_SCLK_PIN
#endif /* Han_Bus_Slave_Diff_UART_Debug_REMOVE_SCLK_PIN */
#ifndef Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS0_PIN
#define Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS0_PIN                 Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS0_PIN
#endif /* Han_Bus_Slave_Diff_UART_Debug_REMOVE_SS0_PIN */

/* Unconfigured pins */
#define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_PIN   Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN
#define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_PIN        Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN
#define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_PIN        Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN
#ifndef Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN
#define Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN               Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN
#endif /* Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN */
#ifndef Han_Bus_Slave_Diff_UART_Debug_SS0_PIN
#define Han_Bus_Slave_Diff_UART_Debug_SS0_PIN                Han_Bus_Slave_Diff_UART_Debug_SS0_PIN
#endif /* Han_Bus_Slave_Diff_UART_Debug_SS0_PIN */

#if (Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_HSIOM_REG     Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_HSIOM_PTR     Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_HSIOM_MASK    Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_HSIOM_POS     Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG

    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_INTCFG_REG    Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_INTCFG_PTR    Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG

    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_INTCFG_TYPE_POS   Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_INTCFG_TYPE_MASK  Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_HSIOM_REG
#endif /* (Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_HSIOM_REG      Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_HSIOM_PTR      Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_PTR
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_HSIOM_MASK     Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_MASK
    #define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_HSIOM_POS      Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_HSIOM_POS
#endif /* (Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_PIN)
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_HSIOM_REG      Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_HSIOM_PTR      Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_HSIOM_MASK     Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_HSIOM_POS      Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_HSIOM_REG
#endif /* (Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_PIN_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN)
    #ifndef Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_REG     Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_PTR     Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_PTR
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_MASK    Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_MASK
    #define Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_POS     Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_POS
    #endif /* Han_Bus_Slave_Diff_UART_Debug_SCLK_HSIOM_REG */
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN) */

#if (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN)
    #ifndef Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_REG      Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_REG
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_PTR      Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_PTR
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_MASK     Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_MASK
    #define Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_POS      Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_POS
    #endif /* Han_Bus_Slave_Diff_UART_Debug_SS0_HSIOM_REG */
#endif /* (Han_Bus_Slave_Diff_UART_Debug_SS0_PIN) */

#define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_PIN_INDEX Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN_INDEX
#define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_PIN_INDEX      Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN_INDEX
#define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_PIN_INDEX      Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN_INDEX
#ifndef Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_INDEX
#define Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_INDEX             Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_INDEX
#endif /* Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_INDEX */
#ifndef Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_INDEX
#define Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_INDEX              Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_INDEX
#endif /* Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_INDEX */

#define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_WAKE_PIN_MASK Han_Bus_Slave_Diff_UART_Debug_RX_WAKE_SCL_MOSI_PIN_MASK
#define Han_Bus_Slave_Diff_UART_Debug_MOSI_SCL_RX_PIN_MASK      Han_Bus_Slave_Diff_UART_Debug_RX_SCL_MOSI_PIN_MASK
#define Han_Bus_Slave_Diff_UART_Debug_MISO_SDA_TX_PIN_MASK      Han_Bus_Slave_Diff_UART_Debug_TX_SDA_MISO_PIN_MASK
#ifndef Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_MASK
#define Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_MASK             Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_MASK
#endif /* Han_Bus_Slave_Diff_UART_Debug_SCLK_PIN_MASK */
#ifndef Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_MASK
#define Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_MASK              Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_MASK
#endif /* Han_Bus_Slave_Diff_UART_Debug_SS0_PIN_MASK */

#endif /* (CY_SCB_PINS_Han_Bus_Slave_Diff_UART_Debug_H) */


/* [] END OF FILE */
