/*******************************************************************************
* File Name: Han_Bus_Slave_Diff_UART_Debug_SCBCLK.h
* Version 2.20
*
*  Description:
*   Provides the function and constant definitions for the clock component.
*
*  Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_CLOCK_Han_Bus_Slave_Diff_UART_Debug_SCBCLK_H)
#define CY_CLOCK_Han_Bus_Slave_Diff_UART_Debug_SCBCLK_H

#include <cytypes.h>
#include <cyfitter.h>


/***************************************
*        Function Prototypes
***************************************/
#if defined CYREG_PERI_DIV_CMD

void Han_Bus_Slave_Diff_UART_Debug_SCBCLK_StartEx(uint32 alignClkDiv);
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Start() \
    Han_Bus_Slave_Diff_UART_Debug_SCBCLK_StartEx(Han_Bus_Slave_Diff_UART_Debug_SCBCLK__PA_DIV_ID)

#else

void Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Start(void);

#endif/* CYREG_PERI_DIV_CMD */

void Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Stop(void);

void Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetFractionalDividerRegister(uint16 clkDivider, uint8 clkFractional);

uint16 Han_Bus_Slave_Diff_UART_Debug_SCBCLK_GetDividerRegister(void);
uint8  Han_Bus_Slave_Diff_UART_Debug_SCBCLK_GetFractionalDividerRegister(void);

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Enable()                         Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Start()
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Disable()                        Han_Bus_Slave_Diff_UART_Debug_SCBCLK_Stop()
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetDividerRegister(clkDivider, reset)  \
    Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetFractionalDividerRegister((clkDivider), 0u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetDivider(clkDivider)           Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetDividerRegister((clkDivider), 1u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetDividerValue(clkDivider)      Han_Bus_Slave_Diff_UART_Debug_SCBCLK_SetDividerRegister((clkDivider) - 1u, 1u)


/***************************************
*             Registers
***************************************/
#if defined CYREG_PERI_DIV_CMD

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_ID     Han_Bus_Slave_Diff_UART_Debug_SCBCLK__DIV_ID

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_REG    (*(reg32 *)CYREG_PERI_DIV_CMD)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CTRL_REG   (*(reg32 *)Han_Bus_Slave_Diff_UART_Debug_SCBCLK__CTRL_REGISTER)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_REG    (*(reg32 *)Han_Bus_Slave_Diff_UART_Debug_SCBCLK__DIV_REGISTER)

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_DIV_SHIFT          (0u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_PA_DIV_SHIFT       (8u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_DISABLE_SHIFT      (30u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_ENABLE_SHIFT       (31u)

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_DISABLE_MASK       ((uint32)((uint32)1u << Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_DISABLE_SHIFT))
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_ENABLE_MASK        ((uint32)((uint32)1u << Han_Bus_Slave_Diff_UART_Debug_SCBCLK_CMD_ENABLE_SHIFT))

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_FRAC_MASK  (0x000000F8u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_FRAC_SHIFT (3u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_INT_MASK   (0xFFFFFF00u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_INT_SHIFT  (8u)

#else 

#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_REG        (*(reg32 *)Han_Bus_Slave_Diff_UART_Debug_SCBCLK__REGISTER)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_ENABLE_REG     Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_REG
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_FRAC_MASK  Han_Bus_Slave_Diff_UART_Debug_SCBCLK__FRAC_MASK
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_FRAC_SHIFT (16u)
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_INT_MASK   Han_Bus_Slave_Diff_UART_Debug_SCBCLK__DIVIDER_MASK
#define Han_Bus_Slave_Diff_UART_Debug_SCBCLK_DIV_INT_SHIFT  (0u)

#endif/* CYREG_PERI_DIV_CMD */

#endif /* !defined(CY_CLOCK_Han_Bus_Slave_Diff_UART_Debug_SCBCLK_H) */

/* [] END OF FILE */
