/*******************************************************************************
* File Name: Timeout.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Timeout_ALIASES_H) /* Pins Timeout_ALIASES_H */
#define CY_PINS_Timeout_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define Timeout_0			(Timeout__0__PC)
#define Timeout_0_PS		(Timeout__0__PS)
#define Timeout_0_PC		(Timeout__0__PC)
#define Timeout_0_DR		(Timeout__0__DR)
#define Timeout_0_SHIFT	(Timeout__0__SHIFT)
#define Timeout_0_INTR	((uint16)((uint16)0x0003u << (Timeout__0__SHIFT*2u)))

#define Timeout_INTR_ALL	 ((uint16)(Timeout_0_INTR))


#endif /* End Pins Timeout_ALIASES_H */


/* [] END OF FILE */
