/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include "`$INSTANCE_NAME`.h"
#include "`$INSTANCE_NAME`_UART.h"
#include "`$INSTANCE_NAME`_Control_Reg.h"
#include "`$INSTANCE_NAME`_Timer.h"
#include "`$INSTANCE_NAME`_TX_Int.h"
#include "`$INSTANCE_NAME`_RX_Int.h"
#include "`$INSTANCE_NAME`_Timeout_Int.h"

#define `$INSTANCE_NAME`_LINK_LED_ON_PORT_0()   {`$INSTANCE_NAME`_control_byte |=      1; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}
#define `$INSTANCE_NAME`_LINK_LED_OFF_PORT_0()  {`$INSTANCE_NAME`_control_byte &= 0xFF-1; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}

#define `$INSTANCE_NAME`_OPEN_PORT_1()          {`$INSTANCE_NAME`_control_byte |=      2; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}
#define `$INSTANCE_NAME`_CLOSE_PORT_1()         {`$INSTANCE_NAME`_control_byte &= 0xFF-2; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}

#define `$INSTANCE_NAME`_OPEN_PORT_2()          {`$INSTANCE_NAME`_control_byte |=      4; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}
#define `$INSTANCE_NAME`_CLOSE_PORT_2()         {`$INSTANCE_NAME`_control_byte &= 0xFF-4; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}

#define `$INSTANCE_NAME`_RECONNECT_PORT_0()     {`$INSTANCE_NAME`_control_byte |=      8; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}
#define `$INSTANCE_NAME`_LOOPBACK_PORT_0()      {`$INSTANCE_NAME`_control_byte &= 0xFF-8; `$INSTANCE_NAME`_Control_Reg_Write(`$INSTANCE_NAME`_control_byte);}

#define `$INSTANCE_NAME`_START_TIMEOUT_TIMER()  {`$INSTANCE_NAME`_Timer_WritePeriod(32000);}

unsigned char  `$INSTANCE_NAME`_message_buffer[256];
unsigned char* `$INSTANCE_NAME`_message_buffer_head;
unsigned char* `$INSTANCE_NAME`_message_buffer_tail;
unsigned int   `$INSTANCE_NAME`_buffer_length = 0;
unsigned char  `$INSTANCE_NAME`_control_byte  = 0;
unsigned char  `$INSTANCE_NAME`_flags         = 0;

#define FLAGS_PORT_1_FOUND_SLAVE        1
#define FLAGS_PORT_2_FOUND_SLAVE        2


#define STATE_WAITING_MESSAGE_START     0
#define STATE_QUERYING_PORT_1           1
#define STATE_QUERYING_PORT_2           2

unsigned char `$INSTANCE_NAME`_state = STATE_WAITING_MESSAGE_START;

#define TOKEN_PORT_QUERY            0xAA
#define TOKEN_PORT_QUERY_REPLY      0xBB
#define TOKEN_PORT_QUERY_TIMEOUT    0x11        // This is not a real token. It's just a value that's use to signal to the port
                                                // query state machine that a timeout happened

#define `$INSTANCE_NAME`_SET_FLAG(f)    {`$INSTANCE_NAME`_flags |=      f;}
#define `$INSTANCE_NAME`_CLEAR_FLAG(f)  {`$INSTANCE_NAME`_flags &= 0xff-f;}
#define `$INSTANCE_NAME`_FLAG_IS_SET(f) (`$INSTANCE_NAME`_flags&f)

void `$INSTANCE_NAME`_Handle_State_Waiting_Message_Start(unsigned char c)
{
    switch (c)
    {
        case TOKEN_PORT_QUERY:
            `$INSTANCE_NAME`_LINK_LED_ON_PORT_0();                      // There's someone talking to us from upstream! Turn on the Link0 LED
            `$INSTANCE_NAME`_CLOSE_PORT_1();                            
            `$INSTANCE_NAME`_CLOSE_PORT_2();
            `$INSTANCE_NAME`_RECONNECT_PORT_0();
            `$INSTANCE_NAME`_UART_PutChar(TOKEN_PORT_QUERY_REPLY);
            CyDelayUs(3);                                               // Wait until token is sent back upstream
            
            `$INSTANCE_NAME`_OPEN_PORT_1();                             // Now send a token to Port 1
            `$INSTANCE_NAME`_LOOPBACK_PORT_0();                         // and make sure any reply comes back to us, not back upstream
            `$INSTANCE_NAME`_UART_PutChar(TOKEN_PORT_QUERY);
            `$INSTANCE_NAME`_state = STATE_QUERYING_PORT_1;
            `$INSTANCE_NAME`_START_TIMEOUT_TIMER();
            break;
    }
}


void `$INSTANCE_NAME`_Handle_State_Querying_Port_1(unsigned char c)
{
    switch (c)
    {
        case TOKEN_PORT_QUERY:                                  // Success!   We got a reply on Port 1.
            `$INSTANCE_NAME`_SET_FLAG(FLAGS_PORT_1_FOUND_SLAVE);
            break;
        
        default:                                                // Strange!   We got a wrong reply on port 1.
            `$INSTANCE_NAME`_CLEAR_FLAG(FLAGS_PORT_1_FOUND_SLAVE);
            break;
    }        

    `$INSTANCE_NAME`_CLOSE_PORT_1();                            // Now send a token to Port 2
    `$INSTANCE_NAME`_OPEN_PORT_2();                             // Now send a token to Port 2
    `$INSTANCE_NAME`_LOOPBACK_PORT_0();                         // and make sure any reply comes back to us, not back upstream
    `$INSTANCE_NAME`_UART_PutChar(TOKEN_PORT_QUERY);
    `$INSTANCE_NAME`_state = STATE_QUERYING_PORT_2;
    `$INSTANCE_NAME`_START_TIMEOUT_TIMER();
}



void `$INSTANCE_NAME`_Handle_State_Querying_Port_2(unsigned char c)
{
    switch (c)
    {
        case TOKEN_PORT_QUERY:                                  // Success!   We got a reply on Port 2.
            `$INSTANCE_NAME`_SET_FLAG(FLAGS_PORT_2_FOUND_SLAVE);
            break;
        
        default:                                                // Strange!   We got a wrong reply on port 2. (or it was a timeout)
            `$INSTANCE_NAME`_CLEAR_FLAG(FLAGS_PORT_2_FOUND_SLAVE);
            break;
    }
    
    `$INSTANCE_NAME`_CLOSE_PORT_2();                                // Now Ports 1 and 2 are closed
    
    if (`$INSTANCE_NAME`_FLAG_IS_SET(FLAGS_PORT_1_FOUND_SLAVE))     // Re-open Port 1 if a slave was found there
    {
        `$INSTANCE_NAME`_OPEN_PORT_1();                             
    }

    if (`$INSTANCE_NAME`_FLAG_IS_SET(FLAGS_PORT_2_FOUND_SLAVE))     // Re-open Port 1 if a slave was found there
    {
        `$INSTANCE_NAME`_OPEN_PORT_2();                             
    }
    
    `$INSTANCE_NAME`_RECONNECT_PORT_0();
    `$INSTANCE_NAME`_state = STATE_WAITING_MESSAGE_START;
}


void `$INSTANCE_NAME`_Spoof_Byte_Received(unsigned char c)
{
    `$INSTANCE_NAME`_Handle_State_Waiting_Message_Start(c);
}


CY_ISR(`$INSTANCE_NAME`_TX_Int_Handler)
{
    //`$INSTANCE_NAME`_TX_Int_Clear_Pending();
    //`$INSTANCE_NAME`_Handle_State_Waiting_Message_Start(c);
}

CY_ISR(`$INSTANCE_NAME`_RX_Int_Handler)
{
    //`$INSTANCE_NAME`_RX_Int_Clear_Pending();
    
    unsigned char c = `$INSTANCE_NAME`_UART_GetChar();
    
    switch(`$INSTANCE_NAME`_state)
    {
        case STATE_WAITING_MESSAGE_START:
            `$INSTANCE_NAME`_Handle_State_Waiting_Message_Start(c);
            break;

        case STATE_QUERYING_PORT_1:
            `$INSTANCE_NAME`_Handle_State_Querying_Port_1(c);
            break;

        case STATE_QUERYING_PORT_2:
            `$INSTANCE_NAME`_Handle_State_Querying_Port_2(c);
            break;
    }
}


CY_ISR(`$INSTANCE_NAME`_Timeout_Int_Handler)
{
    `$INSTANCE_NAME`_Timer_ClearInterrupt(`$INSTANCE_NAME`_Timer_INTR_MASK_TC);
    
    switch(`$INSTANCE_NAME`_state)
    {
        case STATE_WAITING_MESSAGE_START:
            // Do nothing
            break;
        
        case STATE_QUERYING_PORT_1:
            `$INSTANCE_NAME`_Handle_State_Querying_Port_1(TOKEN_PORT_QUERY_TIMEOUT);
            break;

        case STATE_QUERYING_PORT_2:
            `$INSTANCE_NAME`_Handle_State_Querying_Port_2(TOKEN_PORT_QUERY_TIMEOUT);
            break;
        }
}

void Test()
{
    unsigned char i = 0;
  
    /*
    while(1)
    {
        `$INSTANCE_NAME`_UART_PutChar(i++);
        CyDelayUs(300);
    }
    */
    
    `$INSTANCE_NAME`_OPEN_PORT_1();
    while(1)
    {
        `$INSTANCE_NAME`_UART_PutString("Hello");
        CyDelay(5);
    }
}



void `$INSTANCE_NAME`_Start()
{
    
    `$INSTANCE_NAME`_message_buffer_head = `$INSTANCE_NAME`_message_buffer;
    `$INSTANCE_NAME`_message_buffer_tail = `$INSTANCE_NAME`_message_buffer;
    `$INSTANCE_NAME`_buffer_length       = 0;
    `$INSTANCE_NAME`_RECONNECT_PORT_0();
    `$INSTANCE_NAME`_CLOSE_PORT_1();
    `$INSTANCE_NAME`_CLOSE_PORT_2();
    `$INSTANCE_NAME`_LINK_LED_OFF_PORT_0();
    `$INSTANCE_NAME`_UART_Start();
    CyDelay(20);
    
    `$INSTANCE_NAME`_Timer_Start();             // Start the Timeout Timer. It will run, and cause one Timeout signal.
                                                // But don't enable the interrupt yet, because we don't want this one.
    CyDelay(40);                                 // Wait for it to finish once
    `$INSTANCE_NAME`_TX_Int_StartEx(`$INSTANCE_NAME`_TX_Int_Handler);                        // Now enable the interrupt, so we can use it again later.
    `$INSTANCE_NAME`_RX_Int_StartEx(`$INSTANCE_NAME`_RX_Int_Handler);                        // Now enable the interrupt, so we can use it again later.
    `$INSTANCE_NAME`_Timeout_Int_StartEx(`$INSTANCE_NAME`_Timeout_Int_Handler);                        // Now enable the interrupt, so we can use it again later.

    //Test();
}






/* [] END OF FILE */
