/*******************************************************************************
* File Name: main.c
*
* Version: 2.1
*
* Description:
*  This project demonstrates the UART transmission mechanism. 
*  Data is sent through serial port that is visible in the Hyperterminal and on 
*  the LCD. ASCII characters from 0x20 to 0x7F(Space to ~ )  that can be 
*  displayed through Hyperterminal/LCD at the same time Interrupt is triggered
*  and incremented while sending.
*
********************************************************************************
* Copyright 2012, Cypress Semiconductor Corporation. All rights reserved.
* This software is owned by Cypress Semiconductor Corporation and is protected
* by and subject to worldwide patent and copyright laws and treaties.
* Therefore, you may use this software only as provided in the license agreement
* accompanying the software package from which you obtained this software.
* CYPRESS AND ITS SUPPLIERS MAKE NO WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
* WITH REGARD TO THIS SOFTWARE, INCLUDING, BUT NOT LIMITED TO, NONINFRINGEMENT,
* IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*******************************************************************************/

#include <project.h>

#define MASTER
//#define SLAVE


CY_ISR(TX_Int_Handler)
{
    
}


CY_ISR(RX_Int_Handler)
{
    unsigned char c = UART_1_RXDATA_REG;
    #ifdef SLAVE
        if ((c<'0') || (c>'9'))
        {
            Debug_Write(1);
            Debug_Write(0);
        }
        else
        {
            UART_1_TXDATA_REG = c;
        }
    #endif
    
}


int main()
{    
    CyGlobalIntEnable; 

    UART_1_Start();
    TX_Int_StartEx(TX_Int_Handler);
    RX_Int_StartEx(RX_Int_Handler);
    PWM_Start();
    
    while(1)
    {
        #ifdef MASTER
            UART_1_PutString("0123456789");
        #endif
        CyDelayUs(70);
    }

    for(;;) {}
}


/* [] END OF FILE */

